; Definitionen fr Tiny2313

; Belegungen der Atmel-Ports:

;*****************************************************************


;	PA0	 5				Quarz

;   PA1	 4				Quarz		

;   PA2	 1		ISP		Reset



;	PB0	 12	    MCP201	S_RX	

;   PB1	 13 	MCP201	S_TX	

;   PB2	 14		MCP201	Fault Detect

;   PB3	 15				frei															

;   PB4	 16				frei			

;	PB5	 17		ISP		MOSI

;	PB6	 18		ISP		MISO

;	PB7	 18		ISP		SCK



;	PD0	2				FTDI RX 

;	PD1	3				FTDI TX 

;	PD2	6				frei

;	PD3	7				frei

;	PD4	8				frei

;	PD5	9				LED

;	PD6	11		MCP201  CS/WAKE

;

;*****************************************************************



;--- Allgemeines -----------------------------------------------



					
.equ    F_CPU           = 4000000 ; Quarzfrequenz

.equ    CYCLES_PER_US   = ((F_CPU+500000)/1000000)

.equ    UART_BAUD_RATE  = 19200

.equ    UART_BAUD_SELECT= (F_CPU/(UART_BAUD_RATE*16))-1
.equ	CYCLES_PER_MS	= (F_CPU/1000)

.equ	T0_PRESCALER	= 1024
.equ 	MS_TIMER		= 10
.equ	T0_COUNT		= ((MS_TIMER*CYCLES_PER_MS)/T0_PRESCALER)+1

.equ	b	=	31			;19200 bps @ 4 MHz crystal
.equ	sb	=	1			;Number of stop bits (1, 2, ...)

;****Konstanten ******************************************************

.equ	SYNC	=	0x55			; Sync fr LIN
.equ	SYNC_BR =	13				; Anzahl d. Bits im Break

.equ	ADR_MA  =	0xF0			; Master- Adresse LIN
.equ	ADR_SL  =	0xE2			; Slave - Adresse LIN

.equ	ETB		=	0x40			; @ als Endbyte
.equ	STB		=   0x41			; A als Startbyte

.equ	S_VER		= '0'
.equ	S_REV		= '7'

.equ	H_VER		= '0'
.equ	H_REV		= '1'


;**************************** Port-Bits ***************************


.equ	MFD				= PB2		; Fault Detect
.equ	MCS				= PD6		; Wake Up/ Chip Select
.equ	LED				= PD5		; LED fr Debug

;--- SPI ----------------------------------------------------------

/*

.equ	SPI_PORT		= PORTB

.equ	SPI_PIN			= PINB



.equ	SPI_SS			= PB2

.equ	SPI_MOSI		= PB3

.equ	SPI_MISO		= PB4

.equ	SPI_SCK			= PB5

*/
;--- Soft UART -----------------------------------------------------

.equ	S_RxD	= PB0			; Receive pin SoftUART
.equ	S_TxD	= PB1			; Transmit pin SoftUART



;***************************** FLAGS ******************************


.equ		MF   =	7			; Masterframe	
.equ		SF	 =	6			; Slaveframe		
.equ		UF	 = 	5			; Wakeup Frame		

.equ		LRX  =  3			; Regen/lichtwert empfangen
.equ		START=	2			; Systemstart			
.equ  FLAG_RX_END=  1			; Endbyte erwartet
.equ  FLAG_RX_OK =	0			; USB Kommando eingegangen

;**************************** Ram-Reservierungen ******************



;--- Internes Ram ------------------------------------------------





.DSEG                       ; das Folgende kommt ins SRAM
.ORG SRAM_START 			; an den Beginn des SRAM legen 
Buffer: .BYTE   10   

RX_BUF:	.BYTE	2

RXBuffer: .BYTE 10



	


;**************************** Register ****************************



;--- lower Register -----------------------------------------------

.def	SICH_SREG	= r0
.def	BITCNT		= r1
.def	STARTCNT	= r2
.def	BYTECNT		= r3
.def	MFCNT		= r4

.def	NULL		= r5
.def	LICHT_1		= r6
.def	REGEN_1		= r7
.def	LICHT_2		= r8
.def	REGEN_2		= r9
.def	LICHT_3		= r10
.def	REGEN_3		= r11
.def	LICHT		= r12
.def	REGEN		= r13
.def	COUNTER		= r14
	

;--- higher Register ----------------------------------------------



.def	FLAGS		= r16							; Flags fr Funktionen

.def	TEMP_3		= r17
.def	RX_COUNT	= r18
.def	DATA_COUNT	= r19
.def	TXBYTE		= r20
.def	STARTFLAGS	= r21

.def	FRAMECNT	= r22                   		; 

.def	TEMP_2		= r23                   		; Temp-Register

.def	TEMP_1		= r24                   		; Temp-Register

.def	TEMP_0		= r25							; Temp-Register

			
		



; r26/r27, r28/r29, r30/r31 fr X,Y,Z reserviert 



;--- Macros -------------------------------------------------------


.macro  load_p                      ; ldt 16Bit @1 nach @0 High und @0 Low

        ldi     @0H,HIGH(@1)
        ldi     @0L,LOW(@1)

.endmacro

